﻿using System;
using System.Collections.Generic;
using System.Text;

namespace InstallXML
{
    partial class Program
    {


        private static void GetStartupSwitches()
        {
            // The executable may be run in Install or Remove modes
            // Commandline arguments must be retrieved to determine mode
            string[] args = Environment.GetCommandLineArgs();
            string CommandString ="";

            foreach (string arg in args)
            {
                CommandString = CommandString +" " +arg;
            }

            //Console.WriteLine("CommandString = " + CommandString);

            foreach (string arg in args)
            {
                // Console.WriteLine("ARGS = " + arg);
                if (arg.ToUpper() == "/REMOVE")
                {
                    varMODE = "Remove";
                }

                if (arg.ToUpper().Trim() == "/TEMPLATE")
                {
                    CreateBlankTemplate();
                    Console.WriteLine("Please Edit the created Install.xml before invoking the installer");
                    Environment.Exit(0);
                }


                if (arg.ToUpper().Contains("/?") == true)
                {
                    if (CommandString.ToUpper().Contains(" VARDISP") == true)
                        DisplayVariableValuesHelpMenu();
                    else if (CommandString.ToUpper().Contains(" COND") == true)
                        DisplayCondHelpMenu();
                    else if (CommandString.ToUpper().Contains(" APP:EXE") == true)
                        DisplayAppEXEHelpMenu();
                    else if (CommandString.ToUpper().Contains(" APP:MSI") == true)
                        DisplayAppMSIHelpMenu();
                    else if (CommandString.ToUpper().Contains(" APP:MSIRM") == true)
                        DisplayAppMSIRMHelpMenu();
                    else if (CommandString.ToUpper().Contains(" APP:MSU") == true)
                        DisplayAppMSUHelpMenu();
                    else if (CommandString.ToUpper().Contains(" APP:MSP") == true)
                        DisplayAppMSPHelpMenu();
                    else if (CommandString.ToUpper().Contains(" APP:VBS") == true)
                        DisplayAppVBSHelpMenu();
                    else if (CommandString.ToUpper().Contains(" APP:CMD") == true)
                        DisplayAppCMDHelpMenu();
                    else if (CommandString.ToUpper().Contains(" APP:PS1") == true)
                        DisplayAppPS1HelpMenu();
                    else if (CommandString.ToUpper().Contains(" VAR") == true)
                        DisplayVariableHelpMenu();


                    else
                        DisplayRootHelpMenu();
                    Environment.Exit(0);

                }
            }
        }


        private static void DisplayRootHelpMenu()
        {

            // Console.ForegroundColor = ConsoleColor.Cyan;
            // Console.WriteLine("Launcher Usage" + "\r\n");

            WriteFullLine("     Launcher Usage");
            Console.WriteLine("\r\n");
            Console.ForegroundColor = ConsoleColor.White;
            Console.WriteLine(
            "eg. Launcher.exe           - Runs in install mode" + "\r\n" +
            "    Launcher.exe /REMOVE   - Runs in remove mode" + "\r\n" +
            "    Launcher.exe /TEMPLATE - Creates a blank template"
            );

            Console.WriteLine("\r\n");
            Console.WriteLine("    /?           Displays this screen");
            Console.WriteLine("    /? APP:EXE   Help with Executable Install Syntax");
            Console.WriteLine("    /? APP:MSI   Help with Windows Installer Install Syntax");
            Console.WriteLine("    /? APP:MSP   Help with Patch Install Syntax");
            Console.WriteLine("    /? APP:MSU   Help with Microsoft Update Install Syntax");
            Console.WriteLine("    /? APP:VBS   Help with VBScript Install Syntax");
            Console.WriteLine("    /? APP:CMD   Help with Batch File Install Syntax");
            Console.WriteLine("    /? APP:PS1   Help with Powershell Script Install Syntax");
            Console.WriteLine("    /? APP:MSIRM Help Removing Windows Installer Packages Syntax");
            Console.WriteLine("\r\n");
            Console.WriteLine("    /? COND      Help with Conditions  Usage");
            Console.WriteLine("    /? VAR       Help with on Variable Usage");
            Console.WriteLine("    /? VARDISP   Display Current Variable Values");
            Console.WriteLine("");
            Console.WriteLine("Press any key to continue...");
            Console.ReadKey();
        }

        private static void DisplayVariableHelpMenu()
        {
          
            WriteFullLine("     Launcher - Variables");
            Console.WriteLine("\r\n"); 

            Console.ForegroundColor = ConsoleColor.White;
            Console.WriteLine("  Variables may be used within XML Conditions or Arguments");
            Console.WriteLine("");

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @OSYSTEM   ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("= The Operating System e.g." +determineOS() + "\r\n");


            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @PATH      ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("= The local path of the directory containing the launcher" + "\r\n");

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @COMSPEC   ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("= DOS Comspec" + "\r\n");

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  [" + (char)34 + "]   ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("     = Will be replaced with double quotes on execution" + "\r\n");

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @PCNAME    ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("= The name of the local machine" + "\r\n");

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @IPADDRESS ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("= The IP Address (version 4) of the machine" + "\r\n");

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @WINDIR    ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("= The Windows Directory of the machine" + "\r\n");

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @TEMP      ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("= The Temp Directory" + "\r\n");

            Console.WriteLine("");
            Console.WriteLine(
            "\r\n" +
            "  A valid Install.xml file must exist in the same subdirectory as the launcher. " + "\r\n");
            Console.WriteLine("");
            Console.WriteLine("Press any key to continue...");
            Console.ReadKey();
        }


        private static void DisplayVariableValuesHelpMenu()
        {

            WriteFullLine("     Launcher - Variable Values");
            Console.WriteLine("\r\n");

            Console.ForegroundColor = ConsoleColor.White;
            Console.WriteLine("  Current Variables set with this machine");
            Console.WriteLine("");

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @OSYSTEM   ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("      =  "+ determineOS() + "\r\n");

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @DOMAIN    ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("      =  " + ReplaceVariables("@DOMAIN") + "\r\n");

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @USERDOMAIN    ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("  =  " + ReplaceVariables("@DOMAIN") + "\r\n");

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @SHORTDOMAIN");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("     =  " + ReplaceVariables("@SHORTDOMAIN") + "\r\n");

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @PRODUCTNAME");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("     =  " + ReplaceVariables("@PRODUCTNAME") + "\r\n");

            
            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @CPUARCH    ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("     =  " + ReplaceVariables("@CPUArch") + "\r\n");

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @PATH      ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("      =  " + GetPath() + "\r\n");

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @COMSPEC   ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("      =  " + ReplaceVariables("@COMSPEC") + "\r\n");

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @PCNAME    ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("      =  " + ReplaceVariables("@PCNAME") + "\r\n");

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @COMPUTERNAME");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("    =  " + ReplaceVariables("@COMPUTERNAME") + "\r\n");
         
            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @IPADDRESS ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("      =  " + ReplaceVariables("@IPADDRESS") + "\r\n");

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @ALLUSERSPROFILE");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write(" =  " + ReplaceVariables("@AllUsersProfile") + "\r\n");


            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @APPDATA    ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("     =  " + ReplaceVariables("@Appdata") + "\r\n");

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @HOMEDRIVE  ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("     =  " + ReplaceVariables("@Homedrive") + "\r\n");

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @LOGONSERVER");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("     =  " + ReplaceVariables("@Logonserver") + "\r\n");

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @WINDIR     ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("     =  " + ReplaceVariables("@WINDIR") + "\r\n");

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @SYSTEMDIR     ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("  =  " + ReplaceVariables("@SYSTEMDIR") + "\r\n");
            

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("  @TEMP       ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("     =  " + ReplaceVariables("@TEMP") + "\r\n");

            Console.WriteLine("");
            Console.WriteLine("  A valid Install.xml file must exist in the same subdirectory as the launcher. " + "\r\n");
            Console.WriteLine("");
            Console.WriteLine("Press any key to continue...");
            Console.ReadKey();
        }






        private static void DisplayAppEXEHelpMenu()
        {

            WriteFullLine("     Install Executable");
            Console.WriteLine("\r\n");
            Console.ForegroundColor = ConsoleColor.White;
            Console.WriteLine("");
            Console.WriteLine(
            @"<Installer Name=" + (char)34 + "A1" + (char)34 + " Type=" + (char)34 + "EXE" + (char)34 + " Target=" + (char)34 + "MyExe.exe" + (char)34 + " Args=" + (char)34 + "" + (char)34 + " Args2=" + (char)34 + "0" + (char)34 + " Enc=" + (char)34 + "False" + (char)34 + " Conditions=" + (char)34 + "" + (char)34 + "/>" + "\r\n" );
            Console.WriteLine("");
            Console.WriteLine("XML Attributes");
            Console.WriteLine("");
            Console.WriteLine(
            "Name        = A non-functional name used for logging of the install action" + "\r\n" +
            "Type        = Setup EXE install" + "\r\n" +
            "Target      = The executable to be called" + "\r\n" +
            "Args        = Parameters to be passed to the installer" + "\r\n" +
            "Args2       = Acceptable Return Codes for the installer" + "\r\n" +
            "Enc         = Bool value indication command-line is encrypted" + "\r\n" +
            "Conditions  = Conditions to be evaluated before ruinning this install" + "\r\n"
            + "\r\n" +
            "A valid Install.xml file must exist in the same subdirectory as the launcher. " + "\r\n");
            Console.WriteLine("");
            Console.WriteLine("Press any key to continue...");
            Console.ReadKey();
        }

        private static void DisplayAppMSIHelpMenu()
        {
            WriteFullLine("     Launcher - Install Windows Installer");
            Console.WriteLine("\r\n");
            Console.ForegroundColor = ConsoleColor.White;
            Console.WriteLine("");
            Console.WriteLine(
            @"<Installer Name=" + (char)34 + "A1" + (char)34 + " Type=" + (char)34 + "MSI" + (char)34 + " Target=" + (char)34 + "MyMsi.msi" + (char)34 + " Args=" + (char)34 + "" + (char)34 + " Args2=" + (char)34 + "" + (char)34 + " Enc=" + (char)34 + "False" + (char)34 + " Conditions=" + (char)34 + "" + (char)34 + "/>" + "\r\n");
            Console.WriteLine("");
            Console.WriteLine("XML Attributes");
            Console.WriteLine("");
            Console.WriteLine(
            "Name        = A non-functional name used for logging of the install action" + "\r\n" +
            "Type        = MSI" + "\r\n" +
            "Target      = The MSI to be called" + "\r\n" +
            "Args        = Transform Name (if any)" + "\r\n" +
            "Args2       = Additional switches or Public Properties (/qn is already passed)" + "\r\n" +
            "Enc         = Bool value indication command-line is encrypted (not enacted)" + "\r\n" +
            "Conditions  = Conditions to be evaluated before running this install" + "\r\n"
            + "\r\n" +
            "A valid Install.xml file must exist in the same subdirectory as the launcher. " + "\r\n");
            Console.WriteLine("");
            Console.WriteLine("Press any key to continue...");
            Console.ReadKey();
        }

        private static void DisplayAppMSIRMHelpMenu()
        {
            WriteFullLine("     Launcher - Remove MSI");
            Console.WriteLine("\r\n");
            Console.ForegroundColor = ConsoleColor.White;
            Console.WriteLine("");
            Console.WriteLine(
            @"<Installer Name=" + (char)34 + "A1" + (char)34 + " Type=" + (char)34 + "MSIRM" + (char)34 + " Target=" + (char)34 + "{ProductCode}" + (char)34 + " Args=" + (char)34 + "" + (char)34 + " Args2=" + (char)34 + "" + (char)34 + " Enc=" + (char)34 + "False" + (char)34 + " Conditions=" + (char)34 + "" + (char)34 + "/>" + "\r\n");
            Console.WriteLine("");
            Console.WriteLine("XML Attributes");
            Console.WriteLine("");
            Console.WriteLine(
            "Name        = A non-functional name used for logging of the install action" + "\r\n" +
            "Type        = MSIRM" + "\r\n" +
            "Target      = The MSI ProductCode to be uninstalled" + "\r\n" +
            "Args        = " + "\r\n" +
            "Args2       = " + "\r\n" +
            "Enc         = Bool value indication command-line is encrypted (not enacted)" + "\r\n" +
            "Conditions  = Conditions to be evaluated before running this install" + "\r\n"
            + "\r\n" +
            "A valid Install.xml file must exist in the same subdirectory as the launcher. " + "\r\n");
            Console.WriteLine("");
            Console.WriteLine("Press any key to continue...");
            Console.ReadKey();
        }

        private static void DisplayAppMSUHelpMenu()
        {
            WriteFullLine("     Launcher - Install Windows Installer");
            Console.WriteLine("\r\n");
            Console.ForegroundColor = ConsoleColor.White;
            Console.WriteLine("");
            Console.WriteLine(
            @"<Installer Name=" + (char)34 + "A1" + (char)34 + " Type=" + (char)34 + "MSU" + (char)34 + " Target=" + (char)34 + "MyUpdate.msu" + (char)34 + " Args=" + (char)34 + "" + (char)34 + " Args2=" + (char)34 + "" + (char)34 + " Enc=" + (char)34 + "False" + (char)34 + " Conditions=" + (char)34 + "" + (char)34 + "/>" + "\r\n");
            Console.WriteLine("");
            Console.WriteLine("XML Attributes");
            Console.WriteLine("");
            Console.WriteLine(
            "Name        = A non-functional name used for logging of the install action" + "\r\n" +
            "Type        = MSU" + "\r\n" +
            "Target      = The MSU Update to be called" + "\r\n" +
            "Args        = " + "\r\n" +
            "Args2       = " + "\r\n" +
            "Enc         = Bool value indication command-line is encrypted (not enacted)" + "\r\n" +
            "Conditions  = Conditions to be evaluated before running this install" + "\r\n"
            + "\r\n" +
            "A valid Install.xml file must exist in the same subdirectory as the launcher. " + "\r\n");
            Console.WriteLine("");
            Console.WriteLine("Press any key to continue...");
            Console.ReadKey();
        }

        private static void DisplayAppMSPHelpMenu()
        {
            WriteFullLine("     Launcher - Install Microsoft Patch");
            Console.WriteLine("\r\n");
            Console.ForegroundColor = ConsoleColor.White;
            Console.WriteLine("");
            Console.WriteLine(
            @"<Installer Name=" + (char)34 + "A1" + (char)34 + " Type=" + (char)34 + "MSP" + (char)34 + " Target=" + (char)34 + "MyPatch.msp" + (char)34 + " Args=" + (char)34 + "" + (char)34 + " Args2=" + (char)34 + "" + (char)34 + " Enc=" + (char)34 + "False" + (char)34 + " Conditions=" + (char)34 + "" + (char)34 + "/>" + "\r\n");
            Console.WriteLine("");
            Console.WriteLine("XML Attributes");
            Console.WriteLine("");
            Console.WriteLine(
            "Name        = A non-functional name used for logging of the install action" + "\r\n" +
            "Type        = MSP" + "\r\n" +
            "Target      = The MSP Patch to be called" + "\r\n" +
            "Args        = " + "\r\n" +
            "Args2       = " + "\r\n" +
            "Enc         = Bool value indication command-line is encrypted (not enacted)" + "\r\n" +
            "Conditions  = Conditions to be evaluated before running this install" + "\r\n"
            + "\r\n" +
            "A valid Install.xml file must exist in the same subdirectory as the launcher. " + "\r\n");
            Console.WriteLine("");
            Console.WriteLine("Press any key to continue...");
            Console.ReadKey();
        }

        private static void DisplayAppVBSHelpMenu()
        {
            WriteFullLine("     Launcher - VBScript Installer");
            Console.WriteLine("\r\n");
            Console.ForegroundColor = ConsoleColor.White;
            Console.WriteLine("");
            Console.WriteLine(
            @"<Installer Name=" + (char)34 + "A1" + (char)34 + " Type=" + (char)34 + "VBS" + (char)34 + " Target=" + (char)34 + "MyScript.vbs" + (char)34 + " Args=" + (char)34 + "" + (char)34 + " Args2=" + (char)34 + "" + (char)34 + " Enc=" + (char)34 + "False" + (char)34 + " Conditions=" + (char)34 + "" + (char)34 + "/>" + "\r\n");
            Console.WriteLine("");
            Console.WriteLine("XML Attributes");
            Console.WriteLine("");
            Console.WriteLine(
            "Name        = A non-functional name used for logging of the install action" + "\r\n" +
            "Type        = VBS" + "\r\n" +
            "Target      = The VB Script to be called" + "\r\n" +
            "Args        = " + "\r\n" +
            "Args2       = " + "\r\n" +
            "Enc         = Bool value indication command-line is encrypted (not enacted)" + "\r\n" +
            "Conditions  = Conditions to be evaluated before running this install" + "\r\n"
            + "\r\n" +
            "A valid Install.xml file must exist in the same subdirectory as the launcher. " + "\r\n");
            Console.WriteLine("");
            Console.WriteLine("Press any key to continue...");
            Console.ReadKey();
        }

        private static void DisplayAppCMDHelpMenu()
        {
            WriteFullLine("     Launcher - Batch File Install");
            Console.WriteLine("\r\n");
            Console.ForegroundColor = ConsoleColor.White;
            Console.WriteLine("");
            Console.WriteLine(
            @"<Installer Name=" + (char)34 + "A1" + (char)34 + " Type=" + (char)34 + "CMD" + (char)34 + " Target=" + (char)34 + "MyScipt.cmd" + (char)34 + " Args=" + (char)34 + "" + (char)34 + " Args2=" + (char)34 + "" + (char)34 + " Enc=" + (char)34 + "False" + (char)34 + " Conditions=" + (char)34 + "" + (char)34 + "/>" + "\r\n");
            Console.WriteLine("");
            Console.WriteLine("XML Attributes");
            Console.WriteLine("");
            Console.WriteLine(
            "Name        = A non-functional name used for logging of the install action" + "\r\n" +
            "Type        = MSU" + "\r\n" +
            "Target      = The Batch File to be called" + "\r\n" +
            "Args        = " + "\r\n" +
            "Args2       = " + "\r\n" +
            "Enc         = Bool value indication command-line is encrypted (not enacted)" + "\r\n" +
            "Conditions  = Conditions to be evaluated before running this install" + "\r\n"
            + "\r\n" +
            "A valid Install.xml file must exist in the same subdirectory as the launcher. " + "\r\n");
            Console.WriteLine("");
            Console.WriteLine("Press any key to continue...");
            Console.ReadKey();
        }

        private static void DisplayAppPS1HelpMenu()
        {
            WriteFullLine("     Launcher - Powershell Installation");
            Console.WriteLine("\r\n");
            Console.ForegroundColor = ConsoleColor.White;
            Console.WriteLine("");
            Console.WriteLine(
            @"<Installer Name=" + (char)34 + "A1" + (char)34 + " Type=" + (char)34 + "PS1" + (char)34 + " Target=" + (char)34 + "MyScript.psq" + (char)34 + " Args=" + (char)34 + "" + (char)34 + " Args2=" + (char)34 + "" + (char)34 + " Enc=" + (char)34 + "False" + (char)34 + " Conditions=" + (char)34 + "" + (char)34 + "/>" + "\r\n");
            Console.WriteLine("");
            Console.WriteLine("XML Attributes");
            Console.WriteLine("");
            Console.WriteLine(
            "Name        = A non-functional name used for logging of the install action" + "\r\n" +
            "Type        = MSU" + "\r\n" +
            "Target      = The Powershell Script to be called" + "\r\n" +
            "Args        = Powershell switches such as -ExecutionPolicy " + "\r\n" +
            "Args2       = Allowable return codes" + "\r\n" +
            "Enc         = Bool value indication command-line is encrypted (not enacted)" + "\r\n" +
            "Conditions  = Conditions to be evaluated before running this install" + "\r\n"
            + "\r\n" +
            "A valid Install.xml file must exist in the same subdirectory as the launcher. " + "\r\n");
            Console.WriteLine("");
            Console.WriteLine("Press any key to continue...");
            Console.ReadKey();
        }


        private static void DisplayCondHelpMenu()
        {
            WriteFullLine("     Launcher - Conditional Statements");
            Console.WriteLine("\r\n");
            Console.ForegroundColor = ConsoleColor.White;
            Console.WriteLine("");
            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.WriteLine( @"  < Conditions=" + (char)34 + "" + (char)34 + " >  \r\n");
            Console.ForegroundColor = ConsoleColor.White;
            Console.WriteLine("");
            Console.WriteLine("  Positive Conditional statements determine if an installer type should run."); 
            Console.WriteLine("  All Installer types support Conditional statements.");
            Console.WriteLine("");
            Console.WriteLine("  Operators");
            Console.WriteLine("");
            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("     =    ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("Returns positive if both elements are equal" + "\r\n");

            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("    <>    ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("Returns positive if both elements are different \r\n");

            Console.WriteLine("");
            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("   [ARP]= ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write(" 'Myapp' Returns positive is 'string' exists as an installed \r\n");
            Console.WriteLine("                   application.  String is determined by Add / Remove");
            Console.WriteLine("                   Programs.  Note there is no space before the '='");


           // Console.WriteLine(@"     =    Returns positive if both elements are equal ");
           // Console.WriteLine(@"    <>    Returns positive if both elements are different ");
           // Console.WriteLine("");
           // Console.WriteLine("   [ARP]= 'Myapp'  Returns positive is 'string' exists as an installed");

            Console.WriteLine("");
            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.Write("   [ARP]<> ");
            Console.ForegroundColor = ConsoleColor.White;
            Console.Write("'Myapp' Returns positive is 'string' exists as an installed \r\n");

            //Console.WriteLine("   [ARP]<>'Myapp'  Returns positive is 'string' is NOT installed");
            Console.WriteLine("                   application.  String is determined by Add / Remove");
            Console.WriteLine("                   Programs.  Note there is no space before the '='");
            Console.WriteLine("");
            Console.WriteLine("Press any key to continue...");
            Console.ReadKey();
        }










        static void WriteFullLine(string value)
        {
            //
            // This method writes an entire line to the console with the string.
            //
            Console.BackgroundColor = ConsoleColor.DarkBlue;
            Console.ForegroundColor = ConsoleColor.White;
            Console.WriteLine("".PadRight(Console.WindowWidth));
            Console.WriteLine(value.PadRight(Console.WindowWidth)); // <-- see note
            //
            // Reset the color.
            //
            Console.ResetColor();
        }


    }
}
