﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Text;
using System.Xml;
using System.Security.Cryptography.Xml;
using System.Security.Cryptography; // used for generating a Hash
using System.Security.Cryptography.X509Certificates;
using System.Data.SqlClient; // required for connecting to the internal Applications Database
using System.ComponentModel;


namespace InstallXML
{
    partial class Program
    {



        public static bool VerifyFileHash(string FileRef)
        {
            // We know that the Install XML file is already Present
            // All Hashed files should be contained within that file
            // Out goal will be to identify the value of the file hash and compare that to the current
            // hash value of the file on disk

            /*
                string path;
                path = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase).Replace(@"file:\", "");

                XmlDocument xmlDoc = new XmlDocument();
                xmlDoc.Load(path + (char)92 + "Install.xml");
                XmlNode node = xmlDoc.DocumentElement;
                // Create a list of the child nodes of 
                // the first node under the root
                XmlNodeList Actions = node.ChildNodes;

                // Visit each node under the contents section of the XML file
                // We should be able to find the reference for the file we are trying to verify
                // Recurse all entries
                for (int i = 0; i < Actions.Count; i++)
                {
                    if (Actions[i].Name == "Contents")
                    {
                        XmlNodeList InstallActions = Actions[i].ChildNodes;
                        // Display the value of its first child node
                        for (int j = 0; j < InstallActions.Count; j++)
                            switch (InstallActions[j].Name)
                            {
                                case "File":
                                    // Indicates we are looking at a file entry
                                    
                                        // Check to see if this if the file we wish to verify
                                        if (FileRef == InstallActions[j].InnerText)
                                        {
                                            //File file being queried is the same entry we are reading 
                                            string varFileHash = InstallActions[j].Attributes["Hash"].Value;
                                            string varFileName = InstallActions[j].InnerText;
                                            Console.WriteLine(path + (char)92 + varFileName + " " + Upper(varFileHash));

                                            using (HashAlgorithm hashAlg = new SHA1Managed())
                                            {
                                                Console.WriteLine("Opening File " + path + (char)92 + varFileName);
                                                using (Stream file = new FileStream(path + (char)92 + varFileName, FileMode.Open, FileAccess.Read))
                                                {
                                                    byte[] hash = hashAlg.ComputeHash(file);

                                                    // Display the hash code of the file to the console.

                                                    string GenFileHash = BitConverter.ToString(hash);

                                                    GenFileHash =  GenFileHash.Replace("-", "");

                                                    if (GenFileHash == Upper(varFileHash))
                                                    {
                                                        Console.WriteLine("File Hash Confirmed: " + GenFileHash);
                                                        return true;
                                                    }
                                                    else
                                                    { // If the Hashs do not match we need to cancel the current ptocess

                                                        Console.WriteLine("File Hash Fail: " + GenFileHash);
                                                        return false;
                                                    }
                                                  //  Console.WriteLine("Generated Hash: " + GenFileHash);
                                                }
                                            }


                                        }

                                    
                                    break;
                            }
                    }

                }
             * 
                return false;
            */

            return true;




        }
        public static bool VerifyAllFiles()
        {
            // We know that the Install XML file is already Present
            // All Hashed files should be contained within that file
            // Out goal will be to identify the value of the file hash and compare that to the current
            // hash value of the file on disk

            Console.WriteLine("*********************************");
            Console.WriteLine("File Contents Verification Begun");
            Console.WriteLine("");

            string path;
            path = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase).Replace(@"file:\", "");


            XmlDocument xmlDoc = new XmlDocument();
            xmlDoc.Load(path + (char)92 + "Install.xml");
            XmlNode node = xmlDoc.DocumentElement;
            // Create a list of the child nodes of 
            // the first node under the root
            XmlNodeList Actions = node.ChildNodes;

            // Visit each node under the contents section of the XML file
            // We should be able to find the reference for the file we are trying to verify
            // Recurse all entries
            for (int i = 0; i < Actions.Count; i++)
            {
                if (Actions[i].Name == "Contents")
                {
                    XmlNodeList InstallActions = Actions[i].ChildNodes;
                    // Display the value of its first child node
                    for (int j = 0; j < InstallActions.Count; j++)

                        if (InstallActions[j].Name == "File")
                        {
                            //File file being queried is the same entry we are reading 
                            string varFileHash = InstallActions[j].Attributes["Hash"].Value;
                            string varFileName = InstallActions[j].InnerText;
                            Console.WriteLine("  validation: " + varFileName + " " + Upper(varFileHash));

                            using (HashAlgorithm hashAlg = new SHA1Managed())
                            {
                                // Console.WriteLine("Opening File " + path + (char)92 + varFileName);
                                // we need to ensure files are present before attempting operations on them
                                if (File.Exists(path + (char)92 + varFileName))
                                {
                                    using (Stream file = new FileStream(path + (char)92 + varFileName, FileMode.Open, FileAccess.Read))
                                    {
                                        byte[] hash = hashAlg.ComputeHash(file);

                                        // Display the hash code of the file to the console.

                                        string GenFileHash = BitConverter.ToString(hash);

                                        GenFileHash = GenFileHash.Replace("-", "");

                                        if (GenFileHash == Upper(varFileHash))
                                        {
                                            Console.WriteLine("File Hash Confirmed: " + GenFileHash);
                                            // return true;

                                        }
                                        else
                                        { // If the Hashs do not match we need to cancel the current process

                                            Console.WriteLine("File Hash Fail: " + GenFileHash);
                                            return false;
                                        }
                                    }
                                }
                                else
                                {
                                    Console.WriteLine("Required File absent: " + path + (char)92 + varFileName);
                                    return false;
                                }
                            }



                        }





                }

            }
            return true;
        }
        public static bool VerifyPackageAllowed(string PackageName)
        {
            Console.WriteLine("Package Validity Testing");
            SqlConnection myConnection = new SqlConnection("user id=launcher;" +
                                       "password=launcher;server=WE02483247.corp.qed.qld.gov.au\\SqlExpress;" +
                                       "Trusted_Connection=no;" +
                                       "database=WindowsApplications; " +
                                       "connection timeout=30");

            try
            {
                myConnection.Open();

                SqlCommand myCommand = new SqlCommand("SELECT * FROM Applications WHERE Package = @PackageName", myConnection);

                myCommand.Parameters.Add("@PackageName", System.Data.SqlDbType.VarChar, 50).Value = PackageName;



                SqlDataReader myReader = myCommand.ExecuteReader();
                while (myReader.Read())
                {
                    Console.WriteLine("");
                    Console.WriteLine("Supported Package Confirmed");
                    Console.WriteLine(myReader["Package"]);
                    // Console.WriteLine(myReader["Retired"]);

                    try
                    {
                        Console.WriteLine("{0}", Convert.ToBoolean(myReader["Retired"]));
                        if (Convert.ToBoolean(myReader["Retired"]) == false)
                        {
                            Console.WriteLine("Package Not Retired");
                            return true;
                        }
                        else
                        {
                            Console.WriteLine("Package Retired");
                        }

                    }
                    catch (FormatException)
                    {
                        Console.WriteLine("Package Format Status - Bad Format");
                    }
                    catch (InvalidCastException)
                    {
                        Console.WriteLine("Package Format Status - No Conversion");
                    }

                }
                myReader.Close();



            }
            catch (Exception e)
            {
                Console.WriteLine(e.ToString());
            }

            return false;
        }

        public static Boolean VerifyXmlFile(String FileName, String CertificateSubject)
        {
            // Check the args.
            if (null == FileName)
                throw new ArgumentNullException("FileName");
            if (null == CertificateSubject)
                throw new ArgumentNullException("CertificateSubject");

            // Load the certificate from the store.
            X509Certificate2 cert = GetCertificateBySubject(CertificateSubject);

            FileStream stream = new FileStream(FileName, FileMode.Open, FileAccess.Read, FileShare.ReadWrite);

            // Create a new XML document.
            XmlDocument xmlDocument = new XmlDocument();

            // Load the passed XML file into the document. 
            xmlDocument.PreserveWhitespace = true;
            xmlDocument.Load(new XmlTextReader(stream));

            // Create a new SignedXml object and pass it
            // the XML document class.
            SignedXml signedXml = new SignedXml(xmlDocument);

            // Find the "Signature" node and create a new
            // XmlNodeList object.
            XmlNodeList nodeList = xmlDocument.GetElementsByTagName("Signature");

            // Load the signature node.
            signedXml.LoadXml((XmlElement)nodeList[0]);

            // Check the signature and return the result.
            return signedXml.CheckSignature(cert, true);

        }

        public static X509Certificate2 GetCertificateBySubject(string CertificateSubject)
        {
            // Check the args.
            if (null == CertificateSubject)
                throw new ArgumentNullException("CertificateSubject");

            // Load the certificate from the certificate store.
            X509Certificate2 cert = null;

            X509Store store = new X509Store(StoreName.TrustedPublisher, StoreLocation.LocalMachine);

            try
            {
                // Open the store.
                store.Open(OpenFlags.ReadOnly | OpenFlags.OpenExistingOnly);

                // Get the certs from the store.
                X509Certificate2Collection CertCol = store.Certificates;

                // Find the certificate with the specified subject.
                foreach (X509Certificate2 c in CertCol)
                {
                    //  Console.WriteLine("Subject  =" + c.Subject + "'");

                    String str = c.Subject; // containing a long string
                    Int32 i = str.IndexOf(CertificateSubject);

                    if (i > 0)
                    {
                        cert = c;
                        break;
                    }
                }

                // Throw an exception of the certificate was not found.
                if (cert == null)
                {
                    throw new CryptographicException("The certificate could not be found.");
                }
            }
            finally
            {
                // Close the store even if an exception was thrown.
                store.Close();
            }

            return cert;
        }

        public static void VerifyDigiCert()
        {

            try
            {
                // Create a new CspParameters object to specify
                // a key container.
                // CspParameters cspParams = new CspParameters();
                // cspParams.KeyContainerName = "XML_DSIG_RSA_KEY";

                CspParameters cspParams = new CspParameters();
                cspParams.KeyContainerName = "XML_DSIG_RSA_KEY";

                RSACryptoServiceProvider rsaKey = new RSACryptoServiceProvider(cspParams);

                // Create a new RSA signing key and save it in the container. 
                // RSACryptoServiceProvider rsaKey = new RSACryptoServiceProvider(cspParams);

                // Load the certificate from the pfx file.  
                // Console.WriteLine("Loading 509 Certificate");
                // X509Certificate2 certificate = new X509Certificate2("C:\\modevelopment.pfx");

                // Console.WriteLine("Setting 509 Private Key");
                // Set the rsaKey to the certificate's private key            
                //  RSACryptoServiceProvider rsaKey = (RSACryptoServiceProvider)certificate.PrivateKey;

                // Create a new XML document.
                XmlDocument xmlDoc = new XmlDocument();

                // Load an XML file into the XmlDocument object.
                xmlDoc.PreserveWhitespace = true;

                string path;
                path = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase).Replace(@"file:\", "");

                xmlDoc.Load(path + (char)92 + "Install.xml");

                // Verify the signature of the signed XML.
                Console.WriteLine("Verifying signature...");
                bool result = VerifyXml(xmlDoc, rsaKey);

                // Display the results of the signature verification to 
                // the console.
                if (result)
                {
                    Console.WriteLine("The XML signature is valid.");
                }
                else
                {
                    Console.WriteLine("The XML signature is not valid.");
                }

            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
            }
        }

        // Verify the signature of an XML file against an asymmetric 
        // algorithm and return the result.

        public static Boolean VerifyXml(XmlDocument Doc, RSA Key)
        {
            // Check arguments.
            if (Doc == null)
                throw new ArgumentException("Doc");
            if (Key == null)
                throw new ArgumentException("Key");

            // Create a new SignedXml object and pass it
            // the XML document class.
            Console.WriteLine("VerifyXML Object Creation");
            SignedXml signedXml = new SignedXml(Doc);

            // Find the "Signature" node and create a new
            // XmlNodeList object.
            XmlNodeList nodeList = Doc.GetElementsByTagName("Signature");

            // Throw an exception if no signature was found.
            if (nodeList.Count <= 0)
            {
                throw new CryptographicException("Verification failed: No Signature was found in the document.");
            }

            // This example only supports one signature for
            // the entire XML document.  Throw an exception 
            // if more than one signature was found.
            if (nodeList.Count >= 2)
            {
                throw new CryptographicException("Verification failed: More that one signature was found for the document.");
            }

            // Load the first <signature> node.  
            signedXml.LoadXml((XmlElement)nodeList[0]);

            Console.WriteLine("XML Signature Loaded for Verification");
            Console.WriteLine("Key Being Used:" + "");
            // Check the signature and return the result.
            return signedXml.CheckSignature(Key);
        }






    }
}
